﻿using UnityEngine;
using System.Collections;

public class CustomRaycast : MonoBehaviour 
{
	public enum dirList
	{
		Up,
		Left,
		Right,
		Down
	};
	public dirList dirTo;
	public Ray thisRay;
	public LayerMask wannaHit;
	public LayerMask bumperHit;
	public float dist;
	public float length;
	public GameObject Owner;

	public Vector2 direction;

	public Vector3 convertDir(dirList _dir)
	{
		Vector3 res = Vector3.zero;
		switch (_dir)
		{
		case dirList.Down :
			{
				res = new Vector3(0f,length * -1f,0f);
			break;
			}
		case dirList.Up :
			{
				res = new Vector3(0f, length,0f);
				break;
			}
		case dirList.Left :
			{
			res = new Vector3(length * -1f,0f,0f);
				break;
			}
		case dirList.Right :
			{
				res = new Vector3(length,0f,0f);
				break;
			}
		}
		return res;
	}
	
	// Update is called once per frame
	void Update () 
	{
		if (length == 0f)
		{
			Debug.LogError("Raycast won't work if length 0");
		}
		if (Owner != null)
		{
			dist = Vector2.Distance(transform.position, Owner.transform.position) + length;
		}
		thisRay = new Ray(transform.position, direction);
	}


	void OnDrawGizmos()
	{
		if (Application.isEditor)
		{
			direction = convertDir(dirTo);
//			thisRay = new Ray(transform.position, direction);
			Debug.DrawRay(transform.position, direction, Color.red);
//			Debug.DrawRay(thisRay.origin, thisRay.direction, Color.red);
			name = dirTo.ToString();
		}
	}
}
