﻿using UnityEngine;
using System.Collections;

public static class GameEventManager {
	
	public delegate void GameEvent();
	
	public static event GameEvent GameStart, GameOver, Respawn, EndGame, StartScroll;
	public enum GameState
	{
		Live,
		GameOver,
		MainMenu,
		EndGame,
		Trailer
	};
	
	public static void TriggerGameStart(string _trigger)
	{
		if(GameStart != null)
		{
			LevelManager.GAMESTATE = GameState.MainMenu;
			GameStart();
		}
	}
	
	public static void TriggerStartScroll(string _trigger)
	{
		if(GameStart != null && LevelManager.GAMESTATE != GameState.MainMenu)
		{
			LevelManager.GAMESTATE = GameState.Live;
			StartScroll();
		}
	}
	
	public static void TriggerRespawn(string _trigger)
	{
		if( Respawn != null && LevelManager.GAMESTATE != GameState.Live)
		{
			LevelManager.GAMESTATE = GameState.Live;
			Respawn();
		}
	}
	public static void TriggerGameOver(string _trigger)
	{
		if( GameOver != null && LevelManager.GAMESTATE != GameState.GameOver)
		{
			LevelManager.GAMESTATE = GameState.GameOver;
			GameOver();
		}
	}
	
	public static void TriggerEndGame()
	{
		if(EndGame != null && LevelManager.GAMESTATE != GameState.GameOver && LevelManager.GAMESTATE != GameState.MainMenu)
		{
			LevelManager.GAMESTATE = GameState.EndGame;
			EndGame();
		}
	}
}