﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using DG.Tweening;

public class Player : Fegp 
{
	public enum PlayerStateList
	{
		Alive,
		Dead,
		Cutscene
	};
	public static PlayerStateList State;
	private LevelManager levMan;
	[HideInInspector] public tk2dSpriteAnimator anim;
	
	//TUNING VALUES
	public float PlayerInitSpeed;
	public float PlayerAcceleration;
	public float PlayerGravity;
	public float PlayerJumpHeight; // Hauteur saut init
	public Vector2 PlayerMaxSpeed; // NE PAS AUGMENTER
	public float PlayerIncreaseSpeedPitch; // Nombre brut d'addition pour les vitesse

	public float rayLength;
	
	// Player Handling (external)
	[HideInInspector] public float accelerationSpeed; // Using only for acceleration (!=CurrentSPeed)
	[HideInInspector] public float targetSpeed;
	[HideInInspector] private Vector2 amountToMove;
	[HideInInspector] private PlayerPhysics playerPhysics;
	
	// BUMPING THINGS 
	private int dirDashing = 0;
	private bool bumping;
	private int collisionDivisionsX = 4;
	private int collisionDivisionsY = 4;
	private Vector3 s;
	private Vector3 c;
	private Ray ray;
	private RaycastHit HitInfo;
	private float deltaX = 0f;
	private float deltaY = 0f;
	public float CurrentSpeed;
	public tk2dSprite Spr;
	public List<Color> cols;
	public AudioSource Aud;
	
	
	private LevelTools.DirectionList Direction;
	private CustomRaycast.dirList Facing;
	private KeyCode UpTouch = KeyCode.UpArrow;
	private KeyCode LeftTouch = KeyCode.LeftArrow;
	private KeyCode RightTouch = KeyCode.RightArrow;
	private KeyCode DownTouch = KeyCode.DownArrow;
	private Vector2 pushForce;
	private BoxCollider2D Colli;
	private List<RaycastHit> RayList;	
	public float rot;
	
	// Use this for initialization
	public Player Setup (LevelManager _man) 
	{
		playerPhysics = GetComponent<PlayerPhysics>().Setup(this);
		levMan = _man;
		Colli = GetComponent<BoxCollider2D>();
		LevelManager.TUNING.Load<Player>(this);
		CurrentSpeed = PlayerInitSpeed;
		
		Aud = GetComponentInChildren<AudioSource> ();
		Spr = GetComponentInChildren<tk2dSprite> ();

//		TweenParams tParms = new TweenParams().SetLoops(-1, LoopType.Yoyo).SetEase(Ease.InQuart);
//		Spr.transform.DORotate (new Vector3 (0f, 0f,180f), 1f).SetAs(tParms);
		
		GameEventManager.GameStart += GameStart;
		GameEventManager.GameOver += GameOver;
		GameEventManager.Respawn += Respawn;
		GameEventManager.EndGame += EndGame;
		return this;
	}
	
	public void addSpeed()
	{
		CurrentSpeed += PlayerIncreaseSpeedPitch;
	}
	
	#region Update
	void Update () 
	{
		if (State != PlayerStateList.Cutscene && State != PlayerStateList.Dead)
		{					
			rot++;
			Spr.transform.Rotate (0f, 0f, rot);
			if (playerPhysics.movementStopped) 
			{
				targetSpeed = 0;
				accelerationSpeed = 0;
			}

			if (playerPhysics.yMoveStopped) {
				amountToMove.y = 0;
			}
			
			// If player is hitting a roof
			if (playerPhysics.xMoveStopped) {
				//				Debug.Log("xStop");
				amountToMove.x = 0;
			}
			
			// If player is touching the ground
			if (playerPhysics.grounded) 
			{
				amountToMove.y = 0;
			}
			if (Input.GetKeyDown(UpTouch)|| Input.GetKey(KeyCode.A)) 
			{
				Aud.Play();
			}
			if (Input.GetKey(UpTouch) || Input.GetKey(KeyCode.A)) 
			{
//				Aud.Play();
				amountToMove.y = PlayerJumpHeight;	
			}

			if (Input.GetKey(LeftTouch) || Input.GetKey(KeyCode.D))
			{
				Facing = CustomRaycast.dirList.Left;
				targetSpeed = -CurrentSpeed;
			} 
			else if (Input.GetKey(RightTouch) || Input.GetKey(KeyCode.W)) 
			{
				Facing = CustomRaycast.dirList.Right;
				targetSpeed = CurrentSpeed;
			}

			targetSpeed = Input.GetAxisRaw("Horizontal") * CurrentSpeed;
			accelerationSpeed = IncrementTowards (accelerationSpeed, targetSpeed, PlayerAcceleration);
			
			amountToMove.x = accelerationSpeed;
			amountToMove.y -= PlayerGravity * Time.deltaTime;

			if (Facing == CustomRaycast.dirList.Right )
			{
				transform.localScale = new Vector3(-1f, 1f, 0f);
			}
			else
			{
				transform.localScale = new Vector3(1f, 1f, 0f);
			}

			playerPhysics.Move(amountToMove * Time.deltaTime);
		}
	}

	private float IncrementTowards(float n, float target, float a) {
		if (n == target) {
			return n; 
		}
		else {
			float dir = Mathf.Sign(target - n); // must n be increased or decreased to get closer to target
			n += a * Time.deltaTime * dir;
			return (dir == Mathf.Sign(target-n))? n: target; // if n has now passed target then return target, otherwise return n
		}
	}
	#endregion

	void OnTriggerEnter (Collider _coll)
	{
		if (_coll.name == "SpeedBox") {
//			levMan.camSpeed = levMan.camSpeedMax;
		}
		if (_coll.name == "Ending") {
			GameEventManager.TriggerEndGame();
		}
		if (_coll.name == "LastDoor" && levMan.hasGrail) {
			transform.position = levMan.TPSpot.transform.position;
		}
		if (_coll.name == "StartGame") {
			GameEventManager.TriggerStartScroll("player do");
		}
		if (_coll.GetComponent<Checkpoint> () != null) {
			levMan.registerCP(_coll.GetComponent<Checkpoint> ());
		}
		
		if (_coll.GetComponent<Grail> () != null && levMan.hasGrail != true) {
			levMan.hasGrail = true;
			levMan.Rewind();
			_coll.GetComponent<Grail> ().GetComponent<tk2dSprite>().color = Color.clear;
			Debug.Log("finishgoback");
		}

	}
	void OnTriggerExit (Collider _coll)
	{
		if (_coll.name == "SpeedBox") {
			levMan.camSpeed = levMan.initCamSpeed;
		}
	}
	
	
	private void GameStart()
	{
		if (this != null)
		{
			State = PlayerStateList.Cutscene;
		}
	}
	
	private void GameOver()
	{
		if (this != null)
		{
			Spr.color = Color.black;
			State = PlayerStateList.Dead;
		}
	}
	
	private void Respawn()
	{
		if (this != null)
		{
			Spr.color = Color.white;
			transform.rotation = Quaternion.Euler(0f, 0f, 0f);
			if (levMan.currCp != null)
			{
				transform.position = levMan.currCp.playPos;
			}
			CurrentSpeed = PlayerInitSpeed;
			State = PlayerStateList.Alive;
		}
	}
	
	private void EndGame()
	{
		if (this != null)
		{
			State = PlayerStateList.Cutscene;
		}
	}
	
}